Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -4794,204 +4922,163 @@
 ! ------------
 !> Calculate the nucleation rate and the size of critical clusters assuming
-!> ternary nucleation. Parametrisation according to: 
-!> Napari et al. (2002), J. Chem. Phys., 116, 4221-4227 and 
-!> Napari et al. (2002), J. Geophys. Res., 107(D19), AAC 6-1-ACC 6-6. 
-!> Called from subroutine nucleation. 
-!------------------------------------------------------------------------------!
- SUBROUTINE ternucl( pc_sa, pc_nh3, ptemp, prh, pnuc_rate, pn_crit_sa,         &
-                     pn_crit_ocnv, pd_crit, pk_sa, pk_ocnv )
-                     
+!> ternary nucleation. Parametrisation according to:
+!> Napari et al. (2002), J. Chem. Phys., 116, 4221-4227 and
+!> Napari et al. (2002), J. Geophys. Res., 107(D19), AAC 6-1-ACC 6-6.
+!------------------------------------------------------------------------------!
+ SUBROUTINE ternucl( pc_sa, pc_nh3, ptemp, prh, pnuc_rate, pn_crit_sa, pn_crit_ocnv, pd_crit,      &
+                     pk_sa, pk_ocnv )
+
     IMPLICIT NONE
-    
-!-- Input and output variables
-    REAL(wp), INTENT(in) ::   pc_nh3  !< ammonia mixing ratio (ppt)       
+
+    REAL(wp) ::  zlnj     !< logarithm of nucleation rate
+    REAL(wp) ::  zlognh3  !< LOG( pc_nh3 )
+    REAL(wp) ::  zlogrh   !< LOG( prh )
+    REAL(wp) ::  zlogsa   !< LOG( pc_sa )
+
+    REAL(wp), INTENT(in) ::   pc_nh3  !< ammonia mixing ratio (ppt)
     REAL(wp), INTENT(in) ::   pc_sa   !< H2SO4 conc. (#/cm3)
     REAL(wp), INTENT(in) ::   prh     !< relative humidity [0-1]
     REAL(wp), INTENT(in) ::   ptemp   !< ambient temperature (K)
-    REAL(wp), INTENT(out) ::  pd_crit !< diameter of critical 
-                                                  !< cluster (m) 
-    REAL(wp), INTENT(out) ::  pk_ocnv !< Lever: if pk_ocnv = 1,organic compounds 
-                                      !< are involved in nucleation                                                     
-    REAL(wp), INTENT(out) ::  pk_sa   !< Lever: if pk_sa = 1, H2SO4 is involved
-                                      !< in nucleation                                                      
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv !< number of organic molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa   !< number of H2SO4 molecules in 
-                                           !< cluster (#)                                                     
-    REAL(wp), INTENT(out) ::  pnuc_rate    !< nucleation rate (#/(m3 s))
-!-- Local variables
-    REAL(wp) ::  zlnj !< logarithm of nucleation rate
-    
-!-- 1) Checking that we are in the validity range of the parameterization. 
+
+    REAL(wp), INTENT(out) ::  pd_crit  !< diameter of critical cluster (m)
+    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
+    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
+    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucleation rate (#/(m3 s))
+!
+!-- 1) Checking that we are in the validity range of the parameterization.
 !--    Validity of parameterization : DO NOT REMOVE!
     IF ( ptemp < 240.0_wp  .OR.  ptemp > 300.0_wp )  THEN
        message_string = 'Invalid input value: ptemp'
-       CALL message( 'salsa_mod: ternucl', 'SA0045', 1, 2, 0, 6, 0 )
+       CALL message( 'salsa_mod: ternucl', 'PA0619', 1, 2, 0, 6, 0 )
     ENDIF
     IF ( prh < 0.05_wp  .OR.  prh > 0.95_wp )  THEN
        message_string = 'Invalid input value: prh'
-       CALL message( 'salsa_mod: ternucl', 'SA0046', 1, 2, 0, 6, 0 )
+       CALL message( 'salsa_mod: ternucl', 'PA0620', 1, 2, 0, 6, 0 )
     ENDIF
     IF ( pc_sa < 1.0E+4_wp  .OR.  pc_sa > 1.0E+9_wp )  THEN
        message_string = 'Invalid input value: pc_sa'
-       CALL message( 'salsa_mod: ternucl', 'SA0047', 1, 2, 0, 6, 0 )
+       CALL message( 'salsa_mod: ternucl', 'PA0621', 1, 2, 0, 6, 0 )
     ENDIF
     IF ( pc_nh3 < 0.1_wp  .OR.  pc_nh3 > 100.0_wp )  THEN
        message_string = 'Invalid input value: pc_nh3'
-       CALL message( 'salsa_mod: ternucl', 'SA0048', 1, 2, 0, 6, 0 )
+       CALL message( 'salsa_mod: ternucl', 'PA0622', 1, 2, 0, 6, 0 )
     ENDIF
+
+    zlognh3 = LOG( pc_nh3 )
+    zlogrh  = LOG( prh )
+    zlogsa  = LOG( pc_sa )
 !
 !-- 2) Nucleation rate (Eq. 7 in Napari et al., 2002: Parameterization of 
 !--    ternary nucleation of sulfuric acid - ammonia - water.
-    zlnj = - 84.7551114741543_wp                                               &
-           + 0.3117595133628944_wp * prh                                       &
-           + 1.640089605712946_wp * prh * ptemp                                &
-           - 0.003438516933381083_wp * prh * ptemp ** 2.0_wp                   &
-           - 0.00001097530402419113_wp * prh * ptemp ** 3.0_wp                 &
-           - 0.3552967070274677_wp / LOG( pc_sa )                              &
-           - ( 0.06651397829765026_wp * prh ) / LOG( pc_sa )                   &
-           - ( 33.84493989762471_wp * ptemp ) / LOG( pc_sa )                   &
-           - ( 7.823815852128623_wp * prh * ptemp ) / LOG( pc_sa)              &
-           + ( 0.3453602302090915_wp * ptemp ** 2.0_wp ) / LOG( pc_sa )        &
-           + ( 0.01229375748100015_wp * prh * ptemp ** 2.0_wp ) / LOG( pc_sa ) &
-           - ( 0.000824007160514956_wp *ptemp ** 3.0_wp ) / LOG( pc_sa )       &
-           + ( 0.00006185539100670249_wp * prh * ptemp ** 3.0_wp )             &
-             / LOG( pc_sa )                                                    &
-           + 3.137345238574998_wp * LOG( pc_sa )                               &
-           + 3.680240980277051_wp * prh * LOG( pc_sa )                         &
-           - 0.7728606202085936_wp * ptemp * LOG( pc_sa )                      &
-           - 0.204098217156962_wp * prh * ptemp * LOG( pc_sa )                 &
-           + 0.005612037586790018_wp * ptemp ** 2.0_wp * LOG( pc_sa )          &
-           + 0.001062588391907444_wp * prh * ptemp ** 2.0_wp * LOG( pc_sa )    &
-           - 9.74575691760229E-6_wp * ptemp ** 3.0_wp * LOG( pc_sa )           &
-           - 1.265595265137352E-6_wp * prh * ptemp ** 3.0_wp * LOG( pc_sa )    &
-           + 19.03593713032114_wp * LOG( pc_sa ) ** 2.0_wp                     &
-           - 0.1709570721236754_wp * ptemp * LOG( pc_sa ) ** 2.0_wp            &
-           + 0.000479808018162089_wp * ptemp ** 2.0_wp * LOG( pc_sa ) ** 2.0_wp&
-           - 4.146989369117246E-7_wp * ptemp ** 3.0_wp * LOG( pc_sa ) ** 2.0_wp&
-           + 1.076046750412183_wp * LOG( pc_nh3 )                              &
-           + 0.6587399318567337_wp * prh * LOG( pc_nh3 )                       &
-           + 1.48932164750748_wp * ptemp * LOG( pc_nh3 )                       & 
-           + 0.1905424394695381_wp * prh * ptemp * LOG( pc_nh3 )               &
-           - 0.007960522921316015_wp * ptemp ** 2.0_wp * LOG( pc_nh3 )         &
-           - 0.001657184248661241_wp * prh * ptemp ** 2.0_wp * LOG( pc_nh3 )   &
-           + 7.612287245047392E-6_wp * ptemp ** 3.0_wp * LOG( pc_nh3 )         &
-           + 3.417436525881869E-6_wp * prh * ptemp ** 3.0_wp * LOG( pc_nh3 )   &
-           + ( 0.1655358260404061_wp * LOG( pc_nh3 ) ) / LOG( pc_sa)           &
-           + ( 0.05301667612522116_wp * prh * LOG( pc_nh3 ) ) / LOG( pc_sa )   &
-           + ( 3.26622914116752_wp * ptemp * LOG( pc_nh3 ) ) / LOG( pc_sa )    &
-           - ( 1.988145079742164_wp * prh * ptemp * LOG( pc_nh3 ) )            &
-             / LOG( pc_sa )                                                    &
-           - ( 0.04897027401984064_wp * ptemp ** 2.0_wp * LOG( pc_nh3) )       &
-             / LOG( pc_sa )                                                    &
-           + ( 0.01578269253599732_wp * prh * ptemp ** 2.0_wp * LOG( pc_nh3 )  &
-             ) / LOG( pc_sa )                                                  &
-           + ( 0.0001469672236351303_wp * ptemp ** 3.0_wp * LOG( pc_nh3 ) )    &
-             / LOG( pc_sa )                                                    &
-           - ( 0.00002935642836387197_wp * prh * ptemp ** 3.0_wp *LOG( pc_nh3 )&
-             ) / LOG( pc_sa )                                                  &
-           + 6.526451177887659_wp * LOG( pc_sa ) * LOG( pc_nh3 )               & 
-           - 0.2580021816722099_wp * ptemp * LOG( pc_sa ) * LOG( pc_nh3 )      &
-           + 0.001434563104474292_wp * ptemp ** 2.0_wp * LOG( pc_sa )          &
-             * LOG( pc_nh3 )                                                   &
-           -  2.020361939304473E-6_wp * ptemp ** 3.0_wp * LOG( pc_sa )         &
-             * LOG( pc_nh3 )                                                   &
-           - 0.160335824596627_wp * LOG( pc_sa ) ** 2.0_wp * LOG( pc_nh3 )     &
-           +  0.00889880721460806_wp * ptemp * LOG( pc_sa ) ** 2.0_wp          &
-             * LOG( pc_nh3 )                                                   &
-           -  0.00005395139051155007_wp * ptemp ** 2.0_wp                      &
-             * LOG( pc_sa) ** 2.0_wp * LOG( pc_nh3 )                           &
-           +  8.39521718689596E-8_wp * ptemp ** 3.0_wp * LOG( pc_sa ) ** 2.0_wp&
-             * LOG( pc_nh3 )                                                   &
-           + 6.091597586754857_wp * LOG( pc_nh3 ) ** 2.0_wp                    &
-           + 8.5786763679309_wp * prh * LOG( pc_nh3 ) ** 2.0_wp                &
-           - 1.253783854872055_wp * ptemp * LOG( pc_nh3 ) ** 2.0_wp            &
-           - 0.1123577232346848_wp * prh * ptemp * LOG( pc_nh3 ) ** 2.0_wp     &
-           + 0.00939835595219825_wp * ptemp ** 2.0_wp * LOG( pc_nh3 ) ** 2.0_wp&
-           + 0.0004726256283031513_wp * prh * ptemp ** 2.0_wp                  &
-             * LOG( pc_nh3) ** 2.0_wp                                          &
-           - 0.00001749269360523252_wp * ptemp ** 3.0_wp                       &
-             * LOG( pc_nh3 ) ** 2.0_wp                                         &
-           - 6.483647863710339E-7_wp * prh * ptemp ** 3.0_wp                   &
-             * LOG( pc_nh3 ) ** 2.0_wp                                         &
-           + ( 0.7284285726576598_wp * LOG( pc_nh3 ) ** 2.0_wp ) / LOG( pc_sa )&
-           + ( 3.647355600846383_wp * ptemp * LOG( pc_nh3 ) ** 2.0_wp )        &
-             / LOG( pc_sa )                                                    &
-           - ( 0.02742195276078021_wp * ptemp ** 2.0_wp                        &
-             * LOG( pc_nh3) ** 2.0_wp ) / LOG( pc_sa )                         &
-           + ( 0.00004934777934047135_wp * ptemp ** 3.0_wp                     &
-             * LOG( pc_nh3 ) ** 2.0_wp ) / LOG( pc_sa )                        &
-           + 41.30162491567873_wp * LOG( pc_sa ) * LOG( pc_nh3 ) ** 2.0_wp     &
-           - 0.357520416800604_wp * ptemp * LOG( pc_sa )                       &
-             * LOG( pc_nh3 ) ** 2.0_wp                                         &
-           + 0.000904383005178356_wp * ptemp ** 2.0_wp * LOG( pc_sa )          &
-             * LOG( pc_nh3 ) ** 2.0_wp                                         &
-           - 5.737876676408978E-7_wp * ptemp ** 3.0_wp * LOG( pc_sa )          &
-             * LOG( pc_nh3 ) ** 2.0_wp                                         &
-           - 2.327363918851818_wp * LOG( pc_sa ) ** 2.0_wp                     &
-             * LOG( pc_nh3 ) ** 2.0_wp                                         &
-           + 0.02346464261919324_wp * ptemp * LOG( pc_sa ) ** 2.0_wp           &
-             * LOG( pc_nh3 ) ** 2.0_wp                                         &
-           - 0.000076518969516405_wp * ptemp ** 2.0_wp                         &
-             * LOG( pc_sa ) ** 2.0_wp * LOG( pc_nh3 ) ** 2.0_wp                &
-           + 8.04589834836395E-8_wp * ptemp ** 3.0_wp * LOG( pc_sa ) ** 2.0_wp &
-             * LOG( pc_nh3 ) ** 2.0_wp                                         &
-           - 0.02007379204248076_wp * LOG( prh )                               &
-           - 0.7521152446208771_wp * ptemp * LOG( prh )                        &
-           + 0.005258130151226247_wp * ptemp ** 2.0_wp * LOG( prh )            &
-           - 8.98037634284419E-6_wp * ptemp ** 3.0_wp * LOG( prh )             &
-           + ( 0.05993213079516759_wp * LOG( prh ) ) / LOG( pc_sa )            &
-           + ( 5.964746463184173_wp * ptemp * LOG( prh ) ) / LOG( pc_sa )      &
-           - ( 0.03624322255690942_wp * ptemp ** 2.0_wp * LOG( prh ) )         &
-             / LOG( pc_sa )                                                    &
-           + ( 0.00004933369382462509_wp * ptemp ** 3.0_wp * LOG( prh ) )      &
-             / LOG( pc_sa )                                                    &
-           - 0.7327310805365114_wp * LOG( pc_nh3 ) * LOG( prh )                &
-           - 0.01841792282958795_wp * ptemp * LOG( pc_nh3 ) * LOG( prh )       &
-           + 0.0001471855981005184_wp * ptemp ** 2.0_wp * LOG( pc_nh3 )        &
-             * LOG( prh )                                                      &
-           - 2.377113195631848E-7_wp * ptemp ** 3.0_wp * LOG( pc_nh3 )         &
-             * LOG( prh )
+    zlnj = - 84.7551114741543_wp + 0.3117595133628944_wp * prh +                                   &
+           1.640089605712946_wp * prh * ptemp - 0.003438516933381083_wp * prh * ptemp**2 -         &
+           0.00001097530402419113_wp * prh * ptemp**3 - 0.3552967070274677_wp / zlogsa -           &
+           ( 0.06651397829765026_wp * prh ) / zlogsa - ( 33.84493989762471_wp * ptemp ) / zlogsa - &
+           ( 7.823815852128623_wp * prh * ptemp ) / zlogsa +                                       &
+           ( 0.3453602302090915_wp * ptemp**2 ) / zlogsa +                                         &
+           ( 0.01229375748100015_wp * prh * ptemp**2 ) / zlogsa -                                  &
+           ( 0.000824007160514956_wp *ptemp**3 ) / zlogsa +                                        &
+           ( 0.00006185539100670249_wp * prh * ptemp**3 ) / zlogsa +                               &
+           3.137345238574998_wp * zlogsa + 3.680240980277051_wp * prh * zlogsa -                   &
+           0.7728606202085936_wp * ptemp * zlogsa - 0.204098217156962_wp * prh * ptemp * zlogsa +  &
+           0.005612037586790018_wp * ptemp**2 * zlogsa +                                           &
+           0.001062588391907444_wp * prh * ptemp**2 * zlogsa -                                     &
+           9.74575691760229E-6_wp * ptemp**3 * zlogsa -                                            &
+           1.265595265137352E-6_wp * prh * ptemp**3 * zlogsa + 19.03593713032114_wp * zlogsa**2 -  &
+           0.1709570721236754_wp * ptemp * zlogsa**2 +                                             &
+           0.000479808018162089_wp * ptemp**2 * zlogsa**2 -                                        &
+           4.146989369117246E-7_wp * ptemp**3 * zlogsa**2 + 1.076046750412183_wp * zlognh3 +       &
+           0.6587399318567337_wp * prh * zlognh3 + 1.48932164750748_wp * ptemp * zlognh3 +         &
+           0.1905424394695381_wp * prh * ptemp * zlognh3 -                                         &
+           0.007960522921316015_wp * ptemp**2 * zlognh3 -                                          &
+           0.001657184248661241_wp * prh * ptemp**2 * zlognh3 +                                    &
+           7.612287245047392E-6_wp * ptemp**3 * zlognh3 +                                          &
+           3.417436525881869E-6_wp * prh * ptemp**3 * zlognh3 +                                    &
+           ( 0.1655358260404061_wp * zlognh3 ) / zlogsa +                                          &
+           ( 0.05301667612522116_wp * prh * zlognh3 ) / zlogsa +                                   &
+           ( 3.26622914116752_wp * ptemp * zlognh3 ) / zlogsa -                                    &
+           ( 1.988145079742164_wp * prh * ptemp * zlognh3 ) / zlogsa -                             &
+           ( 0.04897027401984064_wp * ptemp**2 * zlognh3 ) / zlogsa +                              &
+           ( 0.01578269253599732_wp * prh * ptemp**2 * zlognh3 ) / zlogsa +                        &
+           ( 0.0001469672236351303_wp * ptemp**3 * zlognh3 ) / zlogsa -                            &
+           ( 0.00002935642836387197_wp * prh * ptemp**3 *zlognh3 ) / zlogsa +                      &
+           6.526451177887659_wp * zlogsa * zlognh3 -                                               &
+           0.2580021816722099_wp * ptemp * zlogsa * zlognh3 +                                      &
+           0.001434563104474292_wp * ptemp**2 * zlogsa * zlognh3 -                                 &
+           2.020361939304473E-6_wp * ptemp**3 * zlogsa * zlognh3 -                                 &
+           0.160335824596627_wp * zlogsa**2 * zlognh3 +                                            &
+           0.00889880721460806_wp * ptemp * zlogsa**2 * zlognh3 -                                  &
+           0.00005395139051155007_wp * ptemp**2 * zlogsa**2 * zlognh3 +                            &
+           8.39521718689596E-8_wp * ptemp**3 * zlogsa**2 * zlognh3 +                               &
+           6.091597586754857_wp * zlognh3**2 + 8.5786763679309_wp * prh * zlognh3**2 -             &
+           1.253783854872055_wp * ptemp * zlognh3**2 -                                             &
+           0.1123577232346848_wp * prh * ptemp * zlognh3**2 +                                      &
+           0.00939835595219825_wp * ptemp**2 * zlognh3**2 +                                        &
+           0.0004726256283031513_wp * prh * ptemp**2 * zlognh3**2 -                                &
+           0.00001749269360523252_wp * ptemp**3 * zlognh3**2 -                                     &
+           6.483647863710339E-7_wp * prh * ptemp**3 * zlognh3**2 +                                 &
+           ( 0.7284285726576598_wp * zlognh3**2 ) / zlogsa +                                       &
+           ( 3.647355600846383_wp * ptemp * zlognh3**2 ) / zlogsa -                                &
+           ( 0.02742195276078021_wp * ptemp**2 * zlognh3**2 ) / zlogsa +                           &
+           ( 0.00004934777934047135_wp * ptemp**3 * zlognh3**2 ) / zlogsa +                        &
+           41.30162491567873_wp * zlogsa * zlognh3**2 -                                            &
+           0.357520416800604_wp * ptemp * zlogsa * zlognh3**2 +                                    &
+           0.000904383005178356_wp * ptemp**2 * zlogsa * zlognh3**2 -                              &
+           5.737876676408978E-7_wp * ptemp**3 * zlogsa * zlognh3**2 -                              &
+           2.327363918851818_wp * zlogsa**2 * zlognh3**2 +                                         &
+           0.02346464261919324_wp * ptemp * zlogsa**2 * zlognh3**2 -                               &
+           0.000076518969516405_wp * ptemp**2 * zlogsa**2 * zlognh3**2 +                           &
+           8.04589834836395E-8_wp * ptemp**3 * zlogsa**2 * zlognh3**2 -                            &
+           0.02007379204248076_wp * zlogrh - 0.7521152446208771_wp * ptemp * zlogrh +              &
+           0.005258130151226247_wp * ptemp**2 * zlogrh -                                           &
+           8.98037634284419E-6_wp * ptemp**3 * zlogrh +                                            &
+           ( 0.05993213079516759_wp * zlogrh ) / zlogsa +                                          &
+           ( 5.964746463184173_wp * ptemp * zlogrh ) / zlogsa -                                    &
+           ( 0.03624322255690942_wp * ptemp**2 * zlogrh ) / zlogsa +                               &
+           ( 0.00004933369382462509_wp * ptemp**3 * zlogrh ) / zlogsa -                            &
+           0.7327310805365114_wp * zlognh3 * zlogrh -                                              &
+           0.01841792282958795_wp * ptemp * zlognh3 * zlogrh +                                     &
+           0.0001471855981005184_wp * ptemp**2 * zlognh3 * zlogrh -                                &
+           2.377113195631848E-7_wp * ptemp**3 * zlognh3 * zlogrh
     pnuc_rate = EXP( zlnj )   ! (#/(cm3 s))
-!    
-!-- Check validity of parametrization             
-    IF ( pnuc_rate < 1.0E-5_wp )  THEN 
+!
+!-- Check validity of parametrization
+    IF ( pnuc_rate < 1.0E-5_wp )  THEN
        pnuc_rate = 0.0_wp
        pd_crit   = 1.0E-9_wp
     ELSEIF ( pnuc_rate > 1.0E6_wp )  THEN
        message_string = 'Invalid output value: nucleation rate > 10^6 1/cm3s'
-       CALL message( 'salsa_mod: ternucl', 'SA0049', 1, 2, 0, 6, 0 )
+       CALL message( 'salsa_mod: ternucl', 'PA0623', 1, 2, 0, 6, 0 )
     ENDIF
     pnuc_rate = pnuc_rate * 1.0E6_wp   ! (#/(m3 s))
-!             
+!
 !-- 3) Number of H2SO4 molecules in a critical cluster (Eq. 9)
-    pn_crit_sa = 38.16448247950508_wp + 0.7741058259731187_wp * zlnj +         &
-                 0.002988789927230632_wp * zlnj ** 2.0_wp -                    &
-                 0.3576046920535017_wp * ptemp -                               &
-                 0.003663583011953248_wp * zlnj * ptemp +                      &
-                 0.000855300153372776_wp * ptemp ** 2.0_wp
-!-- Kinetic limit: at least 2 H2SO4 molecules in a cluster                                 
-    pn_crit_sa = MAX( pn_crit_sa, 2.0E0_wp ) 
-!             
+    pn_crit_sa = 38.16448247950508_wp + 0.7741058259731187_wp * zlnj +                             &
+                 0.002988789927230632_wp * zlnj**2 - 0.3576046920535017_wp * ptemp -               &
+                 0.003663583011953248_wp * zlnj * ptemp + 0.000855300153372776_wp * ptemp**2
+!
+!-- Kinetic limit: at least 2 H2SO4 molecules in a cluster
+    pn_crit_sa = MAX( pn_crit_sa, 2.0E0_wp )
+!
 !-- 4) Size of the critical cluster in nm (Eq. 12)
-    pd_crit = 0.1410271086638381_wp - 0.001226253898894878_wp * zlnj -         &
-              7.822111731550752E-6_wp * zlnj ** 2.0_wp -                       &
-              0.001567273351921166_wp * ptemp -                                &
-              0.00003075996088273962_wp * zlnj * ptemp +                       &
-              0.00001083754117202233_wp * ptemp ** 2.0_wp  
+    pd_crit = 0.1410271086638381_wp - 0.001226253898894878_wp * zlnj -                             &
+              7.822111731550752E-6_wp * zlnj**2 - 0.001567273351921166_wp * ptemp -                &
+              0.00003075996088273962_wp * zlnj * ptemp + 0.00001083754117202233_wp * ptemp**2
     pd_crit = pd_crit * 2.0E-9_wp   ! Diameter in m
 !
 !-- 5) Organic compounds not involved when ternary nucleation assumed
-    pn_crit_ocnv = 0.0_wp 
+    pn_crit_ocnv = 0.0_wp
     pk_sa   = 1.0_wp
     pk_ocnv = 0.0_wp
-    
+
  END SUBROUTINE ternucl
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Calculate the nucleation rate and the size of critical clusters assuming 
-!> kinetic nucleation. Each sulphuric acid molecule forms an (NH4)HSO4 molecule 
+!> Calculate the nucleation rate and the size of critical clusters assuming
+!> kinetic nucleation. Each sulphuric acid molecule forms an (NH4)HSO4 molecule
 !> in the atmosphere and two colliding (NH4)HSO4 molecules form a stable
 !> cluster. See Sihto et al. (2006), Atmos. Chem. Phys., 6(12), 4079-4091.
@@ -5003,32 +5090,29 @@
 !>  dens_abs = 1465  density of - " - [kg/m3]
 !------------------------------------------------------------------------------!
- SUBROUTINE kinnucl( pc_sa, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv,      &
-                     pk_sa, pk_ocnv ) 
-                     
+ SUBROUTINE kinnucl( pc_sa, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv )
+
     IMPLICIT NONE
-    
-!-- Input and output variables
-    REAL(wp), INTENT(in) ::  pc_sa     !< H2SO4 conc. (#/m3)
+
+    REAL(wp), INTENT(in) ::  pc_sa  !< H2SO4 conc. (#/m3)
+
     REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv  !< Lever: if pk_ocnv = 1, organic 
-                                       !< compounds are involved in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa    !< Lever: if pk_sa = 1, H2SO4 is involved
-                                       !< in nucleation 
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv !< number of organic molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa   !< number of H2SO4 molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate    !< nucl. rate (#/(m3 s))
-    
+    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
+    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 is participate in nucleation
+    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
+!
 !-- Nucleation rate (#/(m3 s))
-    pnuc_rate = 5.0E-13_wp * pc_sa ** 2.0_wp * 1.0E+6_wp
+    pnuc_rate = 5.0E-13_wp * pc_sa**2.0_wp * 1.0E+6_wp
+!
 !-- Organic compounds not involved when kinetic nucleation is assumed.
     pn_crit_sa   = 2.0_wp
-    pn_crit_ocnv = 0.0_wp 
+    pn_crit_ocnv = 0.0_wp
     pk_sa        = 1.0_wp
-    pk_ocnv      = 0.0_wp             
+    pk_ocnv      = 0.0_wp
     pd_crit      = 7.9375E-10_wp   ! (m)
-    
+
  END SUBROUTINE kinnucl
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -5038,32 +5122,30 @@
 !> See Riipinen et al. (2007), Atmos. Chem. Phys., 7(8), 1899-1914.
 !------------------------------------------------------------------------------!
- SUBROUTINE actnucl( psa_conc, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv,   &
-                     pk_sa, pk_ocnv, activ ) 
+ SUBROUTINE actnucl( psa_conc, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv, activ )
 
     IMPLICIT NONE
-    
-!-- Input and output variables
-    REAL(wp), INTENT(in) ::  psa_conc !< H2SO4 conc. (#/m3)
-    REAL(wp), INTENT(in) ::  activ    !<
-    REAL(wp), INTENT(out) ::  pd_crit !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv !< Lever: if pk_ocnv = 1, organic 
-                                      !< compounds are involved in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa   !< Lever: if pk_sa = 1, H2SO4 is involved
-                                      !< in nucleation 
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv !< number of organic molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa   !< number of H2SO4 molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate    !< nucl. rate (#/(m3 s))
-    
-!-- act_coeff 1e-7 by default
+
+    REAL(wp), INTENT(in) ::  activ     !< activation coefficient (1e-7 by default)
+    REAL(wp), INTENT(in) ::  psa_conc  !< H2SO4 conc. (#/m3)
+
+    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
+    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
+    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
+    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
+!
+!-- Nucleation rate (#/(m3 s))
     pnuc_rate = activ * psa_conc   ! (#/(m3 s))
+!
 !-- Organic compounds not involved when kinetic nucleation is assumed.
     pn_crit_sa   = 2.0_wp
-    pn_crit_ocnv = 0.0_wp 
+    pn_crit_ocnv = 0.0_wp
     pk_sa        = 1.0_wp
     pk_ocnv      = 0.0_wp
     pd_crit      = 7.9375E-10_wp   ! (m)
+
  END SUBROUTINE actnucl
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -5078,30 +5160,28 @@
 
     IMPLICIT NONE
-    
-!-- Input and output variables
+
+    REAL(wp) ::  a_org = 1.3E-7_wp  !< (1/s) (Paasonen et al. Table 4: median)
+
     REAL(wp), INTENT(in) ::  pc_org   !< organic vapour concentration (#/m3)
-    REAL(wp), INTENT(out) ::  pd_crit !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv !< Lever: if pk_ocnv = 1, organic 
-                                      !< compounds are involved in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa !< Lever: if pk_sa = 1, H2SO4 is involved 
-                                    !< in nucleation 
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv !< number of organic molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa   !< number of H2SO4 molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate    !< nucl. rate (#/(m3 s))
-!-- Local variables
-    REAL(wp) ::  Aorg = 1.3E-7_wp !< (1/s) (Paasonen et al. Table 4: median)
-    
-!-- Homomolecular nuleation - which one?          
-    pnuc_rate = Aorg * pc_org 
+
+    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
+    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
+    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
+    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
+!
+!-- Homomolecular nuleation rate
+    pnuc_rate = a_org * pc_org
+!
 !-- H2SO4 not involved when pure organic nucleation is assumed.
     pn_crit_sa   = 0.0_wp
-    pn_crit_ocnv = 1.0_wp 
+    pn_crit_ocnv = 1.0_wp
     pk_sa        = 0.0_wp
     pk_ocnv      = 1.0_wp
     pd_crit      = 1.5E-9_wp   ! (m)
-    
+
  END SUBROUTINE orgnucl
+
 !------------------------------------------------------------------------------!
 ! Description:
